/**
 * @file Checkbox
 * @author fex
 */
import React from 'react';
import { ClassNamesFn } from '../theme';
interface CheckboxProps {
    id?: string;
    key?: string | number;
    style?: React.CSSProperties;
    type?: string;
    size?: 'sm' | 'lg' | 'small' | 'large';
    label?: string;
    className?: string;
    onChange?: (value: any) => void;
    value?: any;
    containerClass?: string;
    inline?: boolean;
    trueValue?: boolean;
    falseValue?: boolean;
    disabled?: boolean;
    readOnly?: boolean;
    checked?: boolean;
    name?: string;
    classPrefix: string;
    classnames: ClassNamesFn;
    partial?: boolean;
}
export declare class Checkbox extends React.Component<CheckboxProps, any> {
    static defaultProps: {
        trueValue: boolean;
        falseValue: boolean;
        type: string;
    };
    handleCheck(e: React.ChangeEvent<any>): void;
    render(): JSX.Element;
}
declare const _default: React.ComponentClass<Pick<Pick<CheckboxProps, "disabled" | "label" | "style" | "size" | "inline" | "key" | "name" | "id" | "value" | "className" | "classPrefix" | "classnames" | "checked" | "readOnly" | "onChange" | "containerClass" | "partial"> & Partial<Pick<CheckboxProps, "type" | "trueValue" | "falseValue">> & Partial<Pick<{
    trueValue: boolean;
    falseValue: boolean;
    type: string;
}, never>>, "disabled" | "label" | "style" | "size" | "inline" | "key" | "type" | "name" | "id" | "value" | "className" | "checked" | "readOnly" | "onChange" | "containerClass" | "trueValue" | "falseValue" | "partial"> & {
    theme?: string | undefined;
    classPrefix?: string | undefined;
    classnames?: ClassNamesFn | undefined;
}, any> & {
    ComposedComponent: typeof Checkbox;
};
export default _default;
