"use strict";
/**
 * @file 文件入口
 * @author fex
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var factory_1 = require("./factory");
exports.render = factory_1.render;
exports.Renderer = factory_1.Renderer;
exports.getRendererByName = factory_1.getRendererByName;
exports.resolveRenderer = factory_1.resolveRenderer;
exports.filterSchema = factory_1.filterSchema;
var api_1 = require("./utils/api");
exports.wrapFetcher = api_1.wrapFetcher;
exports.buildApi = api_1.buildApi;
var tpl_1 = require("./utils/tpl");
exports.filter = tpl_1.filter;
exports.reigsterTplEnginer = tpl_1.reigsterTplEnginer;
require("./utils/tpl-builtin");
require("./utils/tpl-lodash");
var utils = tslib_1.__importStar(require("./utils/helper"));
exports.utils = utils;
var resize_sensor_1 = require("./utils/resize-sensor");
exports.resizeSensor = resize_sensor_1.resizeSensor;
var IconPicker_icons_1 = require("./renderers/Form/IconPicker-icons");
exports.setIconVendor = IconPicker_icons_1.setIconVendor;
var index_1 = require("./components/index");
exports.NotFound = index_1.NotFound;
exports.AlertComponent = index_1.AlertComponent;
exports.alert = index_1.alert;
exports.confirm = index_1.confirm;
exports.AsideNav = index_1.AsideNav;
exports.Button = index_1.Button;
exports.Checkbox = index_1.Checkbox;
exports.Checkboxes = index_1.Checkboxes;
exports.Collapse = index_1.Collapse;
exports.ColorPicker = index_1.ColorPicker;
exports.DatePicker = index_1.DatePicker;
exports.DateRangePicker = index_1.DateRangePicker;
exports.Drawer = index_1.Drawer;
exports.DropdownButton = index_1.DropdownButton;
exports.Icons = 
// Editor,
index_1.Icons;
exports.Html = index_1.Html;
exports.Layout = index_1.Layout;
exports.LazyComponent = index_1.LazyComponent;
exports.Modal = index_1.Modal;
exports.Overlay = index_1.Overlay;
exports.PopOver = index_1.PopOver;
exports.Radios = index_1.Radios;
exports.Range = index_1.Range;
exports.Rating = index_1.Rating;
exports.Select = 
// RichText,
index_1.Select;
exports.Spinner = index_1.Spinner;
exports.Switch = index_1.Switch;
exports.Textarea = index_1.Textarea;
exports.TitleBar = index_1.TitleBar;
exports.ToastComponent = index_1.ToastComponent;
exports.toast = index_1.toast;
exports.Tooltip = index_1.Tooltip;
exports.TooltipWrapper = index_1.TooltipWrapper;
exports.Tree = index_1.Tree;
// 注册渲染器
require("./renderers/Action");
require("./renderers/Alert");
require("./renderers/Remark");
require("./renderers/ButtonGroup");
require("./renderers/ButtonToolbar");
require("./renderers/DropDownButton");
require("./renderers/Collapse");
require("./renderers/CRUD");
require("./renderers/Pagination");
require("./renderers/Cards");
require("./renderers/Card");
require("./renderers/Date");
require("./renderers/Dialog");
require("./renderers/Divider");
require("./renderers/Each");
require("./renderers/Form/index");
require("./renderers/Form/Control");
require("./renderers/Form/Hidden");
require("./renderers/Form/Text");
require("./renderers/Form/Tag");
require("./renderers/Form/Number");
require("./renderers/Form/Textarea");
require("./renderers/Form/Checkboxes");
require("./renderers/Form/Checkbox");
require("./renderers/Form/City");
require("./renderers/Form/Rating");
require("./renderers/Form/Switch");
require("./renderers/Form/Button");
require("./renderers/Form/ButtonGroup");
require("./renderers/Form/ButtonToolbar");
require("./renderers/Form/Radios");
require("./renderers/Form/List");
require("./renderers/Form/Select");
require("./renderers/Form/Static");
require("./renderers/Form/Date");
require("./renderers/Form/DateRange");
require("./renderers/Form/Repeat");
require("./renderers/Form/Tree");
require("./renderers/Form/TreeSelect");
require("./renderers/Form/Image");
require("./renderers/Form/File");
require("./renderers/Form/Matrix");
require("./renderers/Form/Range");
require("./renderers/Form/Array");
require("./renderers/Form/Combo");
require("./renderers/Form/Container");
require("./renderers/Form/SubForm");
require("./renderers/Form/RichText");
require("./renderers/Form/Editor");
require("./renderers/Form/DiffEditor");
require("./renderers/Form/Grid");
require("./renderers/Form/HBox");
require("./renderers/Form/Panel");
require("./renderers/Form/Color");
require("./renderers/Form/ChainedSelect");
require("./renderers/Form/NestedSelect");
require("./renderers/Form/TransferSelect");
require("./renderers/Form/Service");
require("./renderers/Form/Table");
require("./renderers/Form/Picker");
require("./renderers/Form/IconPicker");
require("./renderers/Form/Formula");
require("./renderers/Form/FieldSet");
require("./renderers/Form/Tabs");
require("./renderers/Form/Group");
require("./renderers/Form/InputGroup");
require("./renderers/Grid");
require("./renderers/HBox");
require("./renderers/VBox");
require("./renderers/Image");
require("./renderers/List");
require("./renderers/Operation");
require("./renderers/Page");
require("./renderers/Panel");
require("./renderers/Plain");
require("./renderers/Spinner");
require("./renderers/Table");
require("./renderers/Tabs");
require("./renderers/Tpl");
require("./renderers/Mapping");
require("./renderers/Progress");
require("./renderers/Status");
require("./renderers/Json");
require("./renderers/Link");
require("./renderers/Switch");
require("./renderers/Wizard");
require("./renderers/Chart");
require("./renderers/Container");
require("./renderers/Service");
require("./renderers/Video");
require("./renderers/Audio");
require("./renderers/Nav");
require("./renderers/Tasks");
require("./renderers/Drawer");
require("./renderers/Wrapper");
require("./renderers/IFrame");
require("./renderers/QRCode");
require("./renderers/Icon");
require("./renderers/Carousel");
var Scoped_1 = tslib_1.__importDefault(require("./Scoped"));
exports.Scoped = Scoped_1.default;
exports.ScopedContext = Scoped_1.ScopedContext;
var Item_1 = require("./renderers/Form/Item");
exports.FormItem = Item_1.FormItem;
// 兼容旧版本用法
require("./compat");
var default_1 = require("./themes/default");
exports.classPrefix = default_1.classPrefix;
exports.classnames = default_1.classnames;
require("./themes/cxd");
var tpl_builtin_1 = require("./utils/tpl-builtin");
exports.registerFilter = tpl_builtin_1.registerFilter;
exports.filterDate = tpl_builtin_1.filterDate;
exports.relativeValueRe = tpl_builtin_1.relativeValueRe;
exports.resolveVariable = tpl_builtin_1.resolveVariable;
var validations_1 = require("./utils/validations");
exports.addRule = validations_1.addRule;
exports.str2rules = validations_1.str2rules;
var Select_1 = require("./components/Select");
exports.normalizeOptions = Select_1.normalizeOptions;
var Options_1 = require("./renderers/Form/Options");
exports.OptionsControl = Options_1.OptionsControl;
//# sourceMappingURL=./index.js.map
