import React from 'react';
import { RendererProps } from '../factory';
import { SchemaNode, Action } from '../types';
import { IItem } from '../store/list';
import { TableCell } from './Table';
export interface CardProps extends RendererProps {
    onCheck: (item: IItem) => void;
    multiple?: boolean;
    highlightClassName?: string;
    hideCheckToggler?: boolean;
    item: IItem;
    checkOnItemClick?: boolean;
}
export declare class Card extends React.Component<CardProps> {
    static defaultProps: Partial<CardProps>;
    static propsList: Array<string>;
    constructor(props: CardProps);
    handleClick(e: React.MouseEvent<HTMLDivElement>): void;
    handleCheck(): void;
    handleAction(e: React.UIEvent<any>, action: Action, ctx: object): void;
    handleQuickChange(values: object, saveImmediately?: boolean, saveSlient?: boolean): void;
    getPopOverContainer(): Element | Text | null;
    renderToolbar(): JSX.Element | null;
    renderActions(): JSX.Element[] | null;
    renderChild(node: SchemaNode, region?: string, key?: any): JSX.Element;
    itemRender(field: any, index: number, props: any): JSX.Element;
    renderFeild(region: string, field: any, key: any, props: any): JSX.Element;
    renderBody(): JSX.Element | JSX.Element[] | null;
    render(): JSX.Element;
}
export declare class CardRenderer extends Card {
}
export declare class CardItemFieldRenderer extends TableCell {
    static defaultProps: {
        wrapperComponent: string;
        column?: object | undefined;
        render?: ((region: string, node: SchemaNode, props?: any) => JSX.Element) | undefined;
        env?: import("../factory").RendererEnv | undefined;
        classPrefix?: string | undefined;
        classnames?: import("../theme").ClassNamesFn | undefined;
        $path?: string | undefined;
        store?: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
            id: import("mobx-state-tree").ISimpleType<string>;
            path: string;
            storeType: import("mobx-state-tree").ISimpleType<string>;
            hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
            data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            updatedAt: number;
            pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
            action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            dialogOpen: false;
            dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            drawerOpen: false;
            drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
        }>, {
            readonly parentStore: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                id: import("mobx-state-tree").ISimpleType<string>;
                path: string;
                storeType: import("mobx-state-tree").ISimpleType<string>;
                hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
                data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                updatedAt: number;
                pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
                action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                dialogOpen: false;
                dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                drawerOpen: false;
                drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            }>, any & {
                initData(data?: object): void;
                reset(): void;
                updateData(data?: object, tag?: object | undefined): void;
                setCurrentAction(action: object): void;
                openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDialog(result?: any): void;
                openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDrawer(result?: any): void;
            }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | null;
        } & {
            initData(data?: object): void;
            reset(): void;
            updateData(data?: object, tag?: object | undefined): void;
            setCurrentAction(action: object): void;
            openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
            closeDialog(result?: any): void;
            openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
            closeDrawer(result?: any): void;
        }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
        data?: {
            [propName: string]: any;
        } | undefined;
        defaultData?: object | undefined;
        className?: string | undefined;
    };
    static propsList: string[];
    render(): JSX.Element;
}
