import React from 'react';
import { FormControlProps } from './Item';
export interface DiffEditorProps extends FormControlProps {
    options?: object;
    language?: string;
    diffValue?: string;
}
export declare class DiffEditor extends React.Component<DiffEditorProps, any> {
    static defaultProps: Partial<DiffEditorProps>;
    state: {
        focused: boolean;
    };
    editor: any;
    monaco: any;
    originalEditor: any;
    modifiedEditor: any;
    toDispose: Array<Function>;
    constructor(props: DiffEditorProps);
    componentWillUnmount(): void;
    handleFocus(): void;
    handleBlur(): void;
    componentDidUpdate(prevProps: any): void;
    editorFactory(containerElement: any, monaco: any, options: any): any;
    handleEditorMounted(editor: any, monaco: any): void;
    handleModifiedEditorChange(): void;
    updateContainerSize(): void;
    render(): JSX.Element;
}
export declare class DiffEditorControlRenderer extends DiffEditor {
    static defaultProps: {
        [x: string]: any;
        options?: object | undefined;
        language?: string | undefined;
        diffValue?: string | undefined;
        error?: string | undefined;
        inputOnly?: boolean | undefined;
        errors?: {
            [propName: string]: string;
        } | undefined;
        defaultValue?: any;
        value?: any;
        onChange?: ((value: any, submitOnChange?: boolean | undefined) => void) | undefined;
        onBulkChange?: ((values: any, submitOnChange?: boolean | undefined) => void) | undefined;
        prinstine?: any;
        setPrinstineValue?: ((value: any) => void) | undefined;
        formMode?: "default" | "inline" | "row" | "horizontal" | undefined;
        formItem?: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
            identifier: import("mobx-state-tree").ISimpleType<string>;
            type: string;
            unique: false;
            loading: false;
            required: false;
            rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                msg: string;
                tag: string;
            }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
            name: import("mobx-state-tree").ISimpleType<string>;
            id: string;
            unsetValueOnInvisible: false;
            validated: false;
            validating: false;
            multiple: false;
            delimiter: string;
            valueField: string;
            labelField: string;
            joinValues: true;
            extractValue: false;
            options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
            expressionsInOptions: false;
            selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
        }>, {
            readonly form: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                id: import("mobx-state-tree").ISimpleType<string>;
                path: string;
                storeType: import("mobx-state-tree").ISimpleType<string>;
                hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
                data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                updatedAt: number;
                pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
                action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                dialogOpen: false;
                dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                drawerOpen: false;
                drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            }> & import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                msg: string;
                error: false;
                fetching: false;
                saving: false;
                busying: false;
                checking: false;
                initializing: false;
                schema: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                schemaKey: string;
            }> & import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                inited: false;
                validated: false;
                submited: false;
                submiting: false;
                validating: false;
                items: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                canAccessSuperData: true;
                persistData: false;
            }>, {
                readonly parentStore: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    id: import("mobx-state-tree").ISimpleType<string>;
                    path: string;
                    storeType: import("mobx-state-tree").ISimpleType<string>;
                    hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
                    data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    updatedAt: number;
                    pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
                    action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    dialogOpen: false;
                    dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    drawerOpen: false;
                    drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    initData(data?: object): void;
                    reset(): void;
                    updateData(data?: object, tag?: object | undefined): void;
                    setCurrentAction(action: object): void;
                    openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                    closeDialog(result?: any): void;
                    openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                    closeDrawer(result?: any): void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | null;
            } & {
                initData(data?: object): void;
                reset(): void;
                updateData(data?: object, tag?: object | undefined): void;
                setCurrentAction(action: object): void;
                openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDialog(result?: any): void;
                openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDrawer(result?: any): void;
            } & {
                readonly loading: boolean;
            } & {
                markFetching: (fetching?: boolean) => void;
                markSaving: (saving?: boolean) => void;
                markBusying: (busying?: boolean) => void;
                fetchInitData: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                fetchData: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                reInitData: (data: object | undefined) => void;
                updateMessage: (msg?: string | undefined, error?: boolean) => void;
                clearMessage: () => void;
                saveRemote: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                fetchSchema: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                checkRemote: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
            } & {
                readonly loading: boolean;
                readonly errors: {
                    [propName: string]: string[];
                };
                getValueByName(name: string): any;
                getPristineValueByName(name: string): any;
                getItemById(id: string): import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
                getItemByName(name: string): import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
                getItemsByName(name: string): import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>[];
                readonly valid: boolean;
                readonly isPristine: boolean;
            } & {
                setInited: (value: boolean) => void;
                setValues: (values: object, tag?: object | undefined) => void;
                setValueByName: (name: string, value: any, isPristine?: boolean) => void;
                submit: (fn?: ((values: object) => Promise<any>) | undefined, hooks?: (() => Promise<any>)[] | undefined) => Promise<any>;
                validate: (hooks?: (() => Promise<any>)[] | undefined, forceValidate?: boolean | undefined) => Promise<boolean>;
                validateFields: (fields: string[]) => Promise<boolean>;
                saveRemote: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                reset: (cb?: ((data: any) => void) | undefined) => void;
                registryItem: (name: string, options?: (Partial<import("mobx-state-tree").ModelCreationType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>>> & {
                    value?: any;
                }) | undefined) => import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>;
                unRegistryItem: (item: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>) => void;
                beforeDetach: () => void;
                syncOptions: () => void;
                setCanAccessSuperData: (value?: boolean) => void;
                deleteValueByName: (name: string) => void;
                getPersistData: () => void;
                setPersistData: (() => void) & import("lodash").Cancelable;
                clearPersistData: () => void;
            }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>;
            readonly value: any;
            readonly prinstine: any;
            readonly errors: string[];
            readonly valid: boolean;
            readonly lastSelectValue: string;
            getSelectedOptions(value?: any): any;
        } & {
            config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                required?: any;
                unique?: any;
                value?: any;
                rules?: string | {
                    [propName: string]: any;
                } | undefined;
                messages?: {
                    [propName: string]: string;
                } | undefined;
                multiple?: boolean | undefined;
                delimiter?: string | undefined;
                valueField?: string | undefined;
                labelField?: string | undefined;
                joinValues?: boolean | undefined;
                extractValue?: boolean | undefined;
                type?: string | undefined;
                id?: string | undefined;
            }) => void;
            changeValue: (value: any, isPrintine?: boolean) => void;
            validate: (hook?: any) => Promise<boolean>;
            setError: (msg: string | string[], tag?: string) => void;
            addError: (msg: string | string[], tag?: string) => void;
            clearError: (tag?: string | undefined) => void;
            setOptions: (options: object[]) => void;
            loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
            syncOptions: (originOptions?: any[] | undefined) => void;
            setLoading: (value: boolean) => void;
            reset: () => void;
        }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
        strictMode?: boolean | undefined;
        renderControl?: ((props: import("../../factory").RendererProps) => JSX.Element) | undefined;
        renderLabel?: boolean | undefined;
        sizeMutable?: boolean | undefined;
        wrap?: boolean | undefined;
        hint?: string | undefined;
        description?: string | undefined;
        descriptionClassName?: string | undefined;
        render?: ((region: string, node: import("../../types").SchemaNode, props?: any) => JSX.Element) | undefined;
        env?: import("../../factory").RendererEnv | undefined;
        classPrefix?: string | undefined;
        classnames?: import("../../theme").ClassNamesFn | undefined;
        $path?: string | undefined;
        store?: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
            id: import("mobx-state-tree").ISimpleType<string>;
            path: string;
            storeType: import("mobx-state-tree").ISimpleType<string>;
            hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
            data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            updatedAt: number;
            pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
            action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            dialogOpen: false;
            dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            drawerOpen: false;
            drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
        }>, {
            readonly parentStore: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                id: import("mobx-state-tree").ISimpleType<string>;
                path: string;
                storeType: import("mobx-state-tree").ISimpleType<string>;
                hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
                data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                updatedAt: number;
                pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
                action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                dialogOpen: false;
                dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                drawerOpen: false;
                drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            }>, any & {
                initData(data?: object): void;
                reset(): void;
                updateData(data?: object, tag?: object | undefined): void;
                setCurrentAction(action: object): void;
                openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDialog(result?: any): void;
                openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDrawer(result?: any): void;
            }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | null;
        } & {
            initData(data?: object): void;
            reset(): void;
            updateData(data?: object, tag?: object | undefined): void;
            setCurrentAction(action: object): void;
            openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
            closeDialog(result?: any): void;
            openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
            closeDrawer(result?: any): void;
        }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
        data?: {
            [propName: string]: any;
        } | undefined;
        defaultData?: object | undefined;
        className?: string | undefined;
    };
}
export declare class DiffEditorRenderer extends DiffEditor {
    static defaultProps: {
        disabled: boolean;
        options?: object | undefined;
        language?: string | undefined;
        diffValue?: string | undefined;
        error?: string | undefined;
        inputOnly?: boolean | undefined;
        errors?: {
            [propName: string]: string;
        } | undefined;
        defaultValue?: any;
        value?: any;
        onChange?: ((value: any, submitOnChange?: boolean | undefined) => void) | undefined;
        onBulkChange?: ((values: any, submitOnChange?: boolean | undefined) => void) | undefined;
        prinstine?: any;
        setPrinstineValue?: ((value: any) => void) | undefined;
        formMode?: "default" | "inline" | "row" | "horizontal" | undefined;
        formItem?: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
            identifier: import("mobx-state-tree").ISimpleType<string>;
            type: string;
            unique: false;
            loading: false;
            required: false;
            rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                msg: string;
                tag: string;
            }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
            name: import("mobx-state-tree").ISimpleType<string>;
            id: string;
            unsetValueOnInvisible: false;
            validated: false;
            validating: false;
            multiple: false;
            delimiter: string;
            valueField: string;
            labelField: string;
            joinValues: true;
            extractValue: false;
            options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
            expressionsInOptions: false;
            selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
        }>, {
            readonly form: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                id: import("mobx-state-tree").ISimpleType<string>;
                path: string;
                storeType: import("mobx-state-tree").ISimpleType<string>;
                hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
                data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                updatedAt: number;
                pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
                action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                dialogOpen: false;
                dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                drawerOpen: false;
                drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            }> & import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                msg: string;
                error: false;
                fetching: false;
                saving: false;
                busying: false;
                checking: false;
                initializing: false;
                schema: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                schemaKey: string;
            }> & import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                inited: false;
                validated: false;
                submited: false;
                submiting: false;
                validating: false;
                items: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                canAccessSuperData: true;
                persistData: false;
            }>, {
                readonly parentStore: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    id: import("mobx-state-tree").ISimpleType<string>;
                    path: string;
                    storeType: import("mobx-state-tree").ISimpleType<string>;
                    hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
                    data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    updatedAt: number;
                    pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
                    action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    dialogOpen: false;
                    dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    drawerOpen: false;
                    drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    initData(data?: object): void;
                    reset(): void;
                    updateData(data?: object, tag?: object | undefined): void;
                    setCurrentAction(action: object): void;
                    openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                    closeDialog(result?: any): void;
                    openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                    closeDrawer(result?: any): void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | null;
            } & {
                initData(data?: object): void;
                reset(): void;
                updateData(data?: object, tag?: object | undefined): void;
                setCurrentAction(action: object): void;
                openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDialog(result?: any): void;
                openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDrawer(result?: any): void;
            } & {
                readonly loading: boolean;
            } & {
                markFetching: (fetching?: boolean) => void;
                markSaving: (saving?: boolean) => void;
                markBusying: (busying?: boolean) => void;
                fetchInitData: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                fetchData: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                reInitData: (data: object | undefined) => void;
                updateMessage: (msg?: string | undefined, error?: boolean) => void;
                clearMessage: () => void;
                saveRemote: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                fetchSchema: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                checkRemote: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
            } & {
                readonly loading: boolean;
                readonly errors: {
                    [propName: string]: string[];
                };
                getValueByName(name: string): any;
                getPristineValueByName(name: string): any;
                getItemById(id: string): import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
                getItemByName(name: string): import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
                getItemsByName(name: string): import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>[];
                readonly valid: boolean;
                readonly isPristine: boolean;
            } & {
                setInited: (value: boolean) => void;
                setValues: (values: object, tag?: object | undefined) => void;
                setValueByName: (name: string, value: any, isPristine?: boolean) => void;
                submit: (fn?: ((values: object) => Promise<any>) | undefined, hooks?: (() => Promise<any>)[] | undefined) => Promise<any>;
                validate: (hooks?: (() => Promise<any>)[] | undefined, forceValidate?: boolean | undefined) => Promise<boolean>;
                validateFields: (fields: string[]) => Promise<boolean>;
                saveRemote: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined) => Promise<any>;
                reset: (cb?: ((data: any) => void) | undefined) => void;
                registryItem: (name: string, options?: (Partial<import("mobx-state-tree").ModelCreationType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>>> & {
                    value?: any;
                }) | undefined) => import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>;
                unRegistryItem: (item: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                    identifier: import("mobx-state-tree").ISimpleType<string>;
                    type: string;
                    unique: false;
                    loading: false;
                    required: false;
                    rules: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    messages: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    errorData: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IModelType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                        msg: string;
                        tag: string;
                    }>, {}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>>;
                    name: import("mobx-state-tree").ISimpleType<string>;
                    id: string;
                    unsetValueOnInvisible: false;
                    validated: false;
                    validating: false;
                    multiple: false;
                    delimiter: string;
                    valueField: string;
                    labelField: string;
                    joinValues: true;
                    extractValue: false;
                    options: import("mobx-state-tree").IOptionalIComplexType<import("mobx-state-tree").IArrayType<import("mobx-state-tree").IType<any, any, any>>>;
                    expressionsInOptions: false;
                    selectedOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                    filteredOptions: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                }>, any & {
                    config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                        required?: any;
                        unique?: any;
                        value?: any;
                        rules?: string | {
                            [propName: string]: any;
                        } | undefined;
                        messages?: {
                            [propName: string]: string;
                        } | undefined;
                        multiple?: boolean | undefined;
                        delimiter?: string | undefined;
                        valueField?: string | undefined;
                        labelField?: string | undefined;
                        joinValues?: boolean | undefined;
                        extractValue?: boolean | undefined;
                        type?: string | undefined;
                        id?: string | undefined;
                    }) => void;
                    changeValue: (value: any, isPrintine?: boolean) => void;
                    validate: (hook?: any) => Promise<boolean>;
                    setError: (msg: string | string[], tag?: string) => void;
                    addError: (msg: string | string[], tag?: string) => void;
                    clearError: (tag?: string | undefined) => void;
                    setOptions: (options: object[]) => void;
                    loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
                    syncOptions: (originOptions?: any[] | undefined) => void;
                    setLoading: (value: boolean) => void;
                    reset: () => void;
                }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>) => void;
                beforeDetach: () => void;
                syncOptions: () => void;
                setCanAccessSuperData: (value?: boolean) => void;
                deleteValueByName: (name: string) => void;
                getPersistData: () => void;
                setPersistData: (() => void) & import("lodash").Cancelable;
                clearPersistData: () => void;
            }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>;
            readonly value: any;
            readonly prinstine: any;
            readonly errors: string[];
            readonly valid: boolean;
            readonly lastSelectValue: string;
            getSelectedOptions(value?: any): any;
        } & {
            config: ({ required, unique, value, rules, messages, delimiter, multiple, valueField, labelField, joinValues, extractValue, type, id, }: {
                required?: any;
                unique?: any;
                value?: any;
                rules?: string | {
                    [propName: string]: any;
                } | undefined;
                messages?: {
                    [propName: string]: string;
                } | undefined;
                multiple?: boolean | undefined;
                delimiter?: string | undefined;
                valueField?: string | undefined;
                labelField?: string | undefined;
                joinValues?: boolean | undefined;
                extractValue?: boolean | undefined;
                type?: string | undefined;
                id?: string | undefined;
            }) => void;
            changeValue: (value: any, isPrintine?: boolean) => void;
            validate: (hook?: any) => Promise<boolean>;
            setError: (msg: string | string[], tag?: string) => void;
            addError: (msg: string | string[], tag?: string) => void;
            clearError: (tag?: string | undefined) => void;
            setOptions: (options: object[]) => void;
            loadOptions: (api: import("../../types").Api, data?: object | undefined, options?: import("../../types").fetchOptions | undefined, clearValue?: boolean | undefined, onChange?: ((value: any) => void) | undefined) => Promise<any>;
            syncOptions: (originOptions?: any[] | undefined) => void;
            setLoading: (value: boolean) => void;
            reset: () => void;
        }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
        strictMode?: boolean | undefined;
        renderControl?: ((props: import("../../factory").RendererProps) => JSX.Element) | undefined;
        renderLabel?: boolean | undefined;
        sizeMutable?: boolean | undefined;
        wrap?: boolean | undefined;
        hint?: string | undefined;
        description?: string | undefined;
        descriptionClassName?: string | undefined;
        render?: ((region: string, node: import("../../types").SchemaNode, props?: any) => JSX.Element) | undefined;
        env?: import("../../factory").RendererEnv | undefined;
        classPrefix?: string | undefined;
        classnames?: import("../../theme").ClassNamesFn | undefined;
        $path?: string | undefined;
        store?: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
            id: import("mobx-state-tree").ISimpleType<string>;
            path: string;
            storeType: import("mobx-state-tree").ISimpleType<string>;
            hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
            data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            updatedAt: number;
            pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
            action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            dialogOpen: false;
            dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            drawerOpen: false;
            drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
        }>, {
            readonly parentStore: import("mobx-state-tree").ModelInstanceType<import("mobx-state-tree").ModelPropertiesDeclarationToProperties<{
                id: import("mobx-state-tree").ISimpleType<string>;
                path: string;
                storeType: import("mobx-state-tree").ISimpleType<string>;
                hasRemoteData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<boolean>>;
                data: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                updatedAt: number;
                pristine: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                parentId: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").ISimpleType<string>>;
                action: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                dialogOpen: false;
                dialogData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
                drawerOpen: false;
                drawerData: import("mobx-state-tree").IOptionalIType<import("mobx-state-tree").IType<any, any, any>>;
            }>, any & {
                initData(data?: object): void;
                reset(): void;
                updateData(data?: object, tag?: object | undefined): void;
                setCurrentAction(action: object): void;
                openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDialog(result?: any): void;
                openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
                closeDrawer(result?: any): void;
            }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | null;
        } & {
            initData(data?: object): void;
            reset(): void;
            updateData(data?: object, tag?: object | undefined): void;
            setCurrentAction(action: object): void;
            openDialog(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
            closeDialog(result?: any): void;
            openDrawer(ctx: any, additonal?: object | undefined, callback?: ((ret: any) => void) | undefined): void;
            closeDrawer(result?: any): void;
        }, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized> | undefined;
        data?: {
            [propName: string]: any;
        } | undefined;
        defaultData?: object | undefined;
        className?: string | undefined;
    };
}
